
function Skinner:BlizzardFrames()
--	self:Debug("BlizzardFrames")

	-- only need to do this once
	if self.initialized.BlizzardFrames then return end
	self.initialized.BlizzardFrames = true

-->>-- Character Frames
	self:CharacterFrames()
	self:PetStableFrame()
	self:SpellBookFrame()
	self:DressUpFrame()
	self:FriendsFrame()
	self:TradeFrame()
--	self:QuestLog() -- checked with EQL3 below
	self:reSizeQW()

-->>-- UIE1 Frames
	self:Tooltips()
	self:MirrorTimers()
	self:QuestTimers()
	self:CastingBar()
	self:StaticPopups()
	self:ChatTabs()
	self:ChatFrames()
	self:ChatEditBox()
	self:LootFrame()
	self:GroupLoot()
	self:ContainerFrames()
	self:StackSplit()
	self:ItemText()
	self:ColorPicker()
	self:WorldMap()
	self:HelpFrame()
	self:KnowledgeBase()
--	self:InspectFrame() -- checked with Voyeur below
	self:BattleScore()
	self:ScriptErrors()
	self:Tutorial()
	self:DropDowns()
-->>-- UIE2  Frames
	self:MenuFrames()
--	self:makeModelFramesRotatable() -- checked with CloseUp below
	self:BankFrame()
	self:MailFrame()
--	self:MainMenuBar() -- checked with Bongos below
	self:CoinPickup()
	self:LFGFrame()

-->>-- NPC Frames
	self:MerchantFrames()
	self:GossipFrame()
	self:TaxiFrame()
	self:QuestFrame()
	self:Battlefields()
	self:ArenaFrame()
	self:ArenaRegistrar()
	self:GuildRegistrar()
	self:Petition()
	self:Tabard()

	self:ViewPort()
	self:TopFrame()
	self:MiddleFrames()
	self:BottomFrame()

end

function Skinner:AddonFrames()
--	self:Debug("AddonFrames")

	-- only need to do this once
	if self.initialized.AddonFrames then return end
	self.initialized.AddonFrames = true

	-- this addon colours the Tooltip Border
	if IsAddOnLoaded("Chippu") then ttBorder = false end

	-- Skin the MenuBar if Bongos isn't loaded
	if not IsAddOnLoaded("Bongos") and not IsAddOnLoaded("Bongos2") then self:MainMenuBar() end

	-- Skin the QuestLog if EQL3 isn't loaded
	-- N.B. Do it here as other Addons use the QuestLog size
	 if not IsAddOnLoaded("EQL3") then self:QuestLog() end

	-- used for Addons that aren't LoadOnDemand
	self:checkAndRunAddOn("ACP")
	self:checkAndRunAddOn("AdvancedTradeSkillWindow")
	self:checkAndRunAddOn("aftt_extreme")
	self:checkAndRunAddOn("AoTRDungeonQuester")
	self:checkAndRunAddOn("ArkInventory")
	self:checkAndRunAddOn("Ash_DoTimer")
	self:checkAndRunAddOn("Atlas")
	self:checkAndRunAddOn("AtlasLoot")
	self:checkAndRunAddOn("AtlasQuest")
	self:checkAndRunAddOn("AuctionFilterPlus")
	self:checkAndRunAddOn("AuldLangSyne")
	self:checkAndRunAddOn("AutoDecline")
	self:checkAndRunAddOn("AutoProfit")
	self:checkAndRunAddOn("AxuItemMenus")
	self:checkAndRunAddOn("Badapples")
	self:checkAndRunAddOn("Baggins")
	self:checkAndRunAddOn("Bagnon")
	self:checkAndRunAddOn("Bagnon_Forever")
	self:checkAndRunAddOn("BankAccountant")
	self:checkAndRunAddOn("BattleChat")
	self:checkAndRunAddOn("beql")
	self:checkAndRunAddOn("BigBankStatement")
	self:checkAndRunAddOn("BigGuild")
	self:checkAndRunAddOn("BigTrouble")
	self:checkAndRunAddOn("Bonuses")
	self:checkAndRunAddOn("BuffQ")
	self:checkAndRunAddOn("BugSack")
	self:checkAndRunAddOn("BuyEmAll")
	self:checkAndRunAddOn("BuyPoisons")
	self:checkAndRunAddOn("Cartographer")
	self:checkAndRunAddOn("CBRipoff")
	self:checkAndRunAddOn("CEnemyCastBar")
	self:checkAndRunAddOn("CharactersViewer")
	self:checkAndRunAddOn("Chatr")
	self:checkAndRunAddOn("Clique")
	self:checkAndRunAddOn("ConcessionStand")
	self:checkAndRunAddOn("Converse")
	self:checkAndRunAddOn("CowTip")
	self:checkAndRunAddOn("CT_MailMod")
	self:checkAndRunAddOn("CT_RaidAssist")
	self:checkAndRunAddOn("CT_RaidTracker")
	self:checkAndRunAddOn("DamageMeters")
	self:checkAndRunAddOn("DBM_RaidTools")
	self:checkAndRunAddOn("DepositBox")
	self:checkAndRunAddOn("DopieArenaInfo")
	self:checkAndRunAddOn("DoubleWide")
	self:checkAndRunAddOn("DuckieBank")
	self:checkAndRunAddOn("Earth")
	self:checkAndRunAddOn("EasyUnlock")
	self:checkAndRunAddOn("EavesDrop")
	self:checkAndRunAddOn("EditingUI")
	self:checkAndRunAddOn("EnchantMe")
	self:checkAndRunAddOn("EngBags")
	self:checkAndRunAddOn("EnhancedStackSplit")
	self:checkAndRunAddOn("EnhancedTradeSkills")
	self:checkAndRunAddOn("Epeen")
	self:checkAndRunAddOn("epgp")
	self:checkAndRunAddOn("EQL3")
	self:checkAndRunAddOn("EquipCompare")
	self:checkAndRunAddOn("Examiner")
	self:checkAndRunAddOn("FactionGrinder")
	self:checkAndRunAddOn("FlightMap")
	self:checkAndRunAddOn("FramesResized")
	self:checkAndRunAddOn("FreierGeist_InstanceTime")
	self:checkAndRunAddOn("FruityLoots")
	self:checkAndRunAddOn("FuBar_DurabilityFu")
	self:checkAndRunAddOn("GCInfo")
	self:checkAndRunAddOn("GemHelper")
	self:checkAndRunAddOn("GemMe")
	self:checkAndRunAddOn("GFW_FeedOMatic")
	self:checkAndRunAddOn("GlowFoSho")
	self:checkAndRunAddOn("GotWood")
	self:checkAndRunAddOn("Grid")
	self:checkAndRunAddOn("GroupCalendar")
	self:checkAndRunAddOn("GuildBankAccount")
	self:checkAndRunAddOn("Guild_Alliance")
	self:checkAndRunAddOn("Hadar_FocusFrame")
	self:checkAndRunAddOn("HatTrick")
	self:checkAndRunAddOn("HealBot")
	self:checkAndRunAddOn("HoloFriends")
	self:checkAndRunAddOn("IgorsMassAuction")
	self:checkAndRunAddOn("ItemDB")
	self:checkAndRunAddOn("ItemEnchantApplication")
	self:checkAndRunAddOn("ItemRack")
	self:checkAndRunAddOn("ItemSync")
	self:checkAndRunAddOn("JasonQuest")
	self:checkAndRunAddOn("Junk")
	self:checkAndRunAddOn("Karma")
	self:checkAndRunAddOn("KC_Items")
	self:checkAndRunAddOn("KingOfTheJungle")
	self:checkAndRunAddOn("KLHThreatMeter")
	self:checkAndRunAddOn("KombatStats")
	self:checkAndRunAddOn("LightHeaded")
	self:checkAndRunAddOn("LinkHeaven")
	self:checkAndRunAddOn("Links")
	self:checkAndRunAddOn("LoadIT")
	self:checkAndRunAddOn("LootLink")
	self:checkAndRunAddOn("LootScroll")
	self:checkAndRunAddOn("Ludwig")
	self:checkAndRunAddOn("MailTo")
	self:checkAndRunAddOn("MCP")
	self:checkAndRunAddOn("MetaMap")
	self:checkAndRunAddOn("MobileFrames")
	self:checkAndRunAddOn("MobMap")
	self:checkAndRunAddOn("Moleskine")
	self:checkAndRunAddOn("MonkeyQuest")
	self:checkAndRunAddOn("MonkeyQuestLog")
	self:checkAndRunAddOn("MultiTips")
	self:checkAndRunAddOn("MusicPlayer")
	self:checkAndRunAddOn("MyBags")
	self:checkAndRunAddOn("myBindings")
	self:checkAndRunAddOn("myMusic")
	self:checkAndRunAddOn("Notebook")
	self:checkAndRunAddOn("NotesUNeed")
	self:checkAndRunAddOn("nQuestLog")
	self:checkAndRunAddOn("Omen")
	self:checkAndRunAddOn("Omnibus")
	self:checkAndRunAddOn("OneBag")
	self:checkAndRunAddOn("Outfitter")
	self:checkAndRunAddOn("PallyPower")
	self:checkAndRunAddOn("PartyQuests")
	-- Perl Classic
	self:checkAndRunAddOn("Perl_CombatDisplay")
	self:checkAndRunAddOn("Perl_Focus")
	self:checkAndRunAddOn("Perl_Party")
	self:checkAndRunAddOn("Perl_Party_Pet")
	self:checkAndRunAddOn("Perl_Party_Target")
	self:checkAndRunAddOn("Perl_Player")
	self:checkAndRunAddOn("Perl_Player_Pet")
	self:checkAndRunAddOn("Perl_Target")
	self:checkAndRunAddOn("Perl_Target_Target")
	--
	self:checkAndRunAddOn("PoliteWhisper")
	self:checkAndRunAddOn("Possessions")
	self:checkAndRunAddOn("Postal")
	self:checkAndRunAddOn("Prat")
	self:checkAndRunAddOn("ProcMeter")
	self:checkAndRunAddOn("ProfessionsBook")
	self:checkAndRunAddOn("Proximo")
	self:checkAndRunAddOn("PVPCooldown")
	self:checkAndRunAddOn("PVPCooldownReborn")
	self:checkAndRunAddOn("PvpMessages")
	self:checkAndRunAddOn("QuestHistory")
	self:checkAndRunAddOn("QuestIon")
	self:checkAndRunAddOn("RABuffs")
	self:checkAndRunAddOn("ReagentHeaven")
	self:checkAndRunAddOn("Recap")
	self:checkAndRunAddOn("RecipeBook")
	self:checkAndRunAddOn("RecipeRadar")
	self:checkAndRunAddOn("Recount")
	self:checkAndRunAddOn("Sanity2")
	self:checkAndRunAddOn("SanityBags")
	self:checkAndRunAddOn("sienasGemViewer")
	self:checkAndRunAddOn("SimpleMouseoverTarget")
	self:checkAndRunAddOn("SmartDebuff")
	self:checkAndRunAddOn("SpamSentry")
	self:checkAndRunAddOn("SpellBinder")
	self:checkAndRunAddOn("StanceSets")
	self:checkAndRunAddOn("SuperInspect_UI")
	self:checkAndRunAddOn("SuperMacro")
	self:checkAndRunAddOn("SW_Stats")
	self:checkAndRunAddOn("SW_UniLog")
	self:checkAndRunAddOn("Talented")
	self:checkAndRunAddOn("TankPoints")
	self:checkAndRunAddOn("tekKompare")
	self:checkAndRunAddOn("TinyTip")
	self:checkAndRunAddOn("TipBuddy")
	self:checkAndRunAddOn("TitanExitGame")
	self:checkAndRunAddOn("Toons")
	self:checkAndRunAddOn("UberQuest")
	self:checkAndRunAddOn("VanasKoS")
	self:checkAndRunAddOn("vBagnon")
	self:checkAndRunAddOn("Violation")
	self:checkAndRunAddOn("Visor2GUI")
	self:checkAndRunAddOn("WIM")
	self:checkAndRunAddOn("xcalc")
	-- XPerl
	self:checkAndRunAddOn("XPerl_Party")
	self:checkAndRunAddOn("XPerl_PartyPet")
	self:checkAndRunAddOn("XPerl_Player")
	self:checkAndRunAddOn("XPerl_PlayerPet")
	self:checkAndRunAddOn("XPerl_RaidAdmin")
	self:checkAndRunAddOn("XPerl_RaidFrames")
	self:checkAndRunAddOn("XPerl_RaidHelper")
	self:checkAndRunAddOn("XPerl_RaidMonitor")
	self:checkAndRunAddOn("XPerl_RaidPets")
	self:checkAndRunAddOn("XPerl_Target")
	self:checkAndRunAddOn("XPerl_TargetTarget")
	--
	self:checkAndRunAddOn("XRS")


	-- handle Addons with odd names here
	self:checkAndRunAddOn("Auto-Bag", nil, "AutoBag")
	self:checkAndRunAddOn("Enchantrix-Barker", nil, "EnchantrixBarker")
    self:checkAndRunAddOn("!ImprovedErrorFrame", nil, "ImprovedErrorFrame")

	-- this addon has a relation
	self:checkAndRunAddOn("EnhancedTradeSkills", nil, "EnhancedTradeCrafts")

	-- this addon accesses the Blizzard_InspectUI
	if IsAddOnLoaded("Voyeur") then self:InspectFrame() end

	-- this addon accesses the Blizzard_AuctionUI
	if IsAddOnLoaded("IgorsMassAuction") then self:AuctionFrame() end

	-- this addon accesses the Blizzard_TalentUI
	if IsAddOnLoaded("Planner") then self:TalentFrame() end

	-- skin Dewdrop, Tablet & Waterfall frames
	if AceLibrary:HasInstance("Dewdrop-2.0") then
		if self.Dewdrop then self:Dewdrop()
		else
 			if self.db.profile.Warnings then
				self:CustomPrint(1, 0, 0, nil, nil, nil, "Dewdrop", "loaded but skin not found in SkinMe directory")
			end
		end
	end
	if AceLibrary:HasInstance("Tablet-2.0") then
		if self.Tablet then self:Tablet()
		else
 			if self.db.profile.Warnings then
				self:CustomPrint(1, 0, 0, nil, nil, nil, "Tablet", "loaded but skin not found in SkinMe directory")
			end
		end
	end
	if AceLibrary:HasInstance("Waterfall-1.0") then
		if self.Waterfall then self:Waterfall()
		else
 			if self.db.profile.Warnings then
				self:CustomPrint(1, 0, 0, nil, nil, nil, "Waterfall", "loaded but skin not found in SkinMe directory")
			end
		end
	end
	
	--	Don't make Model Frames Rotatable if CloseUp is loaded
	if not IsAddOnLoaded("CloseUp") then self:makeModelFramesRotatable() end

	-- Skin the AceAddon Donation Frame
	self:OpenDonationFrame()
	AceAddon20Frame:Hide()
	self:keepFontStrings(AceAddon20FrameScrollFrame)
	self:skinScrollBar(AceAddon20FrameScrollFrame)
	self:applySkin(AceAddon20Frame)
	-- Skin the AceAddon About Frame
	self:PrintAddonInfo()
	AceAddon20AboutFrame:Hide()
	self:applySkin(AceAddon20AboutFrame)

end

function Skinner:LoDFrames(arg1)
--	self:Debug("LoDFrames: [%s]", arg1)

	if arg1 == prev_arg1 then return end
	prev_arg1 = arg1

	-- used for Blizzard LoadOnDemand Addons
	if arg1 == "Blizzard_BattlefieldMinimap" then self:BattlefieldMinimap() end
	if arg1 == "Blizzard_BindingUI" then self:KeyBindingFrame() end
	if arg1 == "Blizzard_CraftUI" then self:CraftFrame() end
	if arg1 == "Blizzard_GMSurveyUI" then self:GMSurveyUI() end
	if arg1 == "Blizzard_InspectUI" then self:InspectFrame() end
	if arg1 == "Blizzard_ItemSocketingUI" then self:ItemSocketingUI() end
	if arg1 == "Blizzard_MacroUI" then self:MacroFrame() end
	if arg1 == "Blizzard_RaidUI" then self:RaidUI() end
	if arg1 == "Blizzard_TalentUI" then self:TalentFrame() end
	if arg1 == "Blizzard_TradeSkillUI" then self:TradeSkill() end
	if arg1 == "Blizzard_TrainerUI" then self:ClassTrainer() end

	-- used for User LoadOnDemand Addons
	if arg1 == "AutoBarConfig" then self:checkAndRunAddOn("AutoBarConfig", true) end
	if arg1 == "Bagnon_Options" then self:checkAndRunAddOn("Bagnon_Options", true) end
 	if arg1 == "Bagnon" then self:checkAndRunAddOn("Bagnon", true) end
	if arg1 == "Banknon" then self:checkAndRunAddOn("Banknon", true) end
	if arg1 == "CECB_Options" then self:checkAndRunAddOn("CECB_Options", true) end
	if arg1 == "cgCrafty" then self:checkAndRunAddOn("cgCrafty", true) end
	if arg1 == "CharacterInfo" then self:checkAndRunAddOn("CharacterInfo", true) end
	if arg1 == "DBM_GUI" then self:checkAndRunAddOn("DBM_GUI", true) end
	if arg1 == "EnhTooltip" then self:checkAndRunAddOn("EnhTooltip", true) end
	if arg1 == "FilterTradeSkill" then self:checkAndRunAddOn("FilterTradeSkill", true) end
	if arg1 == "FramesResized_TalentUI" then self:checkAndRunAddOn("FramesResized_TalentUI", true) end
	if arg1 == "ItemRackOptions" then self:checkAndRunAddOn("ItemRackOptions", true) end
	if arg1 == "OneBank" then self:checkAndRunAddOn("OneBank", true) end
	if arg1 == "Perl_Config_Options" then self:checkAndRunAddOn("Perl_Config_Options", true) end
	if arg1 == "SpamSentry_report" then self:checkAndRunAddOn("SpamSentry_report", true) end
	if arg1 == "SpecialTalentUI" then self:checkAndRunAddOn("SpecialTalentUI", true) end
	if arg1 == "SuperInspect_UI" then self:checkAndRunAddOn("SuperInspect_UI", true) end
	if arg1 == "WIM_Options" then self:checkAndRunAddOn("WIM_Options", true) end
	if arg1 == "XPerl_Options" then self:checkAndRunAddOn("XPerl_Options", true) end
	-- Fix for Mrs. Steele's issue
	if arg1 == "Enchantrix" then self:checkAndRunAddOn("Enchantrix", true) end

--	MobMap Stubs
	if arg1 == "MobMapDatabaseStub1" then self:checkAndRunAddOn("MobMapDatabaseStub1", true) end
	if arg1 == "MobMapDatabaseStub2" then self:checkAndRunAddOn("MobMapDatabaseStub2", true) end
	if arg1 == "MobMapDatabaseStub3" then self:checkAndRunAddOn("MobMapDatabaseStub3", true) end
	if arg1 == "MobMapDatabaseStub4" then self:checkAndRunAddOn("MobMapDatabaseStub4", true) end
	if arg1 == "MobMapDatabaseStub5" then self:checkAndRunAddOn("MobMapDatabaseStub5", true) end
	if arg1 == "MobMapDatabaseStub7" then self:checkAndRunAddOn("MobMapDatabaseStub7", true) end
	if arg1 == "MobMapDatabaseStub8" then self:checkAndRunAddOn("MobMapDatabaseStub8", true) end

end

function Skinner:ADDON_LOADED(arg1)
-- self:Debug("ADDON_LOADED: [%s]", arg1)

	self:ScheduleEvent(self.LoDFrames, self.db.profile.Delay.LoDs, self, arg1)

end

function Skinner:AUCTION_HOUSE_SHOW()
--	self:Debug("AUCTION_HOUSE_SHOW")

	if self.initialized.AuctionFrame then return end

	self:AuctionFrame()
	-- trigger these when AH loads otherwise errors occur
	self:checkAndRunAddOn("Auctioneer")
	self:checkAndRunAddOn("BeanCounter")
	self:checkAndRunAddOn("BtmScan")
	self:checkAndRunAddOn("Fence")

end

function Skinner:ViewPort()
	if not self.db.profile.ViewPort.shown or self.initialized.ViewPort then return end
	self.initialized.ViewPort = true

	WorldFrame:SetPoint("TOPLEFT", 0, -(self.db.profile.ViewPort.top * self.db.profile.ViewPort.scaling))
	WorldFrame:SetPoint("BOTTOMRIGHT", -0, (self.db.profile.ViewPort.bottom * self.db.profile.ViewPort.scaling))

	if self.db.profile.ViewPort.overlay then
		ViewportOverlay = WorldFrame:CreateTexture(nil, "BACKGROUND")
		ViewportOverlay:SetTexture(self.db.profile.ViewPort.r or 0, self.db.profile.ViewPort.g or 0, self.db.profile.ViewPort.b or 0, ba or self.db.profile.ViewPort.a or 1)
		ViewportOverlay:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -1, 1)
		ViewportOverlay:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 1, -1)
	end

end

function Skinner:ViewPort_top()
	if not self.db.profile.ViewPort.shown then return end

	WorldFrame:SetPoint("TOPLEFT", 0, -(self.db.profile.ViewPort.top * self.db.profile.ViewPort.scaling))

end

function Skinner:ViewPort_bottom()
	if not self.db.profile.ViewPort.shown then return end

	WorldFrame:SetPoint("BOTTOMRIGHT", -0, (self.db.profile.ViewPort.bottom * self.db.profile.ViewPort.scaling))

end

function Skinner:ViewPort_reset()

	self.initialized.ViewPort = nil
    WorldFrame:SetPoint("TOPLEFT", 0, -0)
	WorldFrame:SetPoint("BOTTOMRIGHT", -0, 0)

end

function Skinner:TopFrame()
	if not self.db.profile.TopFrame.shown or self.initialized.TopFrame then return end
	self.initialized.TopFrame = true

	local fh = nil

	local frame = CreateFrame("Frame", "SkinnerTF", UIParent)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(false)
	frame:SetMovable(false)
	frame:SetWidth(self.db.profile.TopFrame.width or 1920)
	frame:SetHeight(self.db.profile.TopFrame.height or 100)
	frame:ClearAllPoints()
	if self.db.profile.TopFrame.xyOff or self.db.profile.TopFrame.borderOff then
		frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -6, 6)
	else
		frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -3, 3)
	end
	local fb = self.db.profile.TopFrame.borderOff and 0 or 1
	-- set the fade height
	if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
	-- set the Fade Height to the global value if 'forced'
	-- making sure that it isn't greater than the frame height
		fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
	elseif self.db.profile.TopFrame.fheight then
		fh = self.db.profile.TopFrame.fheight <= math.ceil(frame:GetHeight()) and self.db.profile.TopFrame.fheight or math.ceil(frame:GetHeight())
	end
	self:applySkin(frame, nil, fb, self.db.profile.TopFrame.alpha, fh)

	-- TopFrame Gradient settings
	orientation = self.db.profile.TopFrame.rotate and "HORIZONTAL" or "VERTICAL"
	gradientOnTF = self.db.profile.TopFrame.invert and {orientation, MaxR, MaxG, MaxB, MaxA, MinR, MinG, MinB, MinA} or {orientation, MinR, MinG, MinB, MinA, MaxR, MaxG, MaxB, MaxA}
	gradientOffTF = {orientation, 0, 0, 0, 1, 0, 0, 0, 1}

	if self.db.profile.TopFrame.invert then
		frame.tfade:ClearAllPoints()
		frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, 4)
		frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", 4, (fh - 4))
	end
--	apply the Gradient
	frame.tfade:SetGradientAlpha(unpack(self.db.profile.Gradient.enable and gradientOnTF or gradientOffTF))
	-- keep a reference to the frame
	self.topframe = frame

	self:adjustTFOffset(nil)

end

function Skinner:adjustTFOffset(reset)

	--	Adjust the UIParent TOP-OFFSET attribute if required
	if self.initialized.TopFrame then
		local topOfs    = -self.db.profile.TopFrame.height
		local UIPtopOfs = -104
		if topOfs < UIPtopOfs and not reset then
			UIParent:SetAttribute("TOP_OFFSET", topOfs)
		elseif UIParent:GetAttribute("TOP_OFFSET") < UIPtopOfs then
			UIParent:SetAttribute("TOP_OFFSET", UIPtopOfs)
		end
	end

end

function Skinner:MiddleFrames()

    for i = 1, 9 do
		if self.db.profile["MiddleFrame"..i].shown then self:createMiddleFrame(i) end
	end

end

function Skinner:BottomFrame()
	if not self.db.profile.BottomFrame.shown or self.initialized.BottomFrame then return end
	self.initialized.BottomFrame = true

	local fh = nil

	local frame = CreateFrame("Frame", "SkinnerBF", UIParent)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(false)
	frame:SetMovable(false)
	frame:SetWidth(self.db.profile.BottomFrame.width or 1920)
	frame:SetHeight(self.db.profile.BottomFrame.height or 200)
	frame:ClearAllPoints()
	if self.db.profile.BottomFrame.xyOff  or self.db.profile.BottomFrame.borderOff then
		frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", -6, -6)
	else
		frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", -3, -3)
	end
	local fb = self.db.profile.BottomFrame.borderOff and 0 or 1
	-- set the fade height
	if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
	-- set the Fade Height to the global value if 'forced'
	-- making sure that it isn't greater than the frame height
		fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
	elseif self.db.profile.BottomFrame.fheight then
		fh = self.db.profile.BottomFrame.fheight <= math.ceil(frame:GetHeight()) and self.db.profile.BottomFrame.fheight or math.ceil(frame:GetHeight())
	end
	self:applySkin(frame, nil, fb, self.db.profile.BottomFrame.alpha, fh)

	-- BottomFrame Gradient settings
	orientation = self.db.profile.BottomFrame.rotate and "HORIZONTAL" or "VERTICAL"
	gradientOnBF = self.db.profile.BottomFrame.invert and {orientation, MaxR, MaxG, MaxB, MaxA, MinR, MinG, MinB, MinA} or {orientation, MinR, MinG, MinB, MinA, MaxR, MaxG, MaxB, MaxA}
	gradientOffBF = {orientation, 0, 0, 0, 1, 0, 0, 0, 1}

	if self.db.profile.BottomFrame.invert then
		frame.tfade:ClearAllPoints()
		frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, 4)
		frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", 4, (fh - 4))
	end
	--	apply the Gradient
	frame.tfade:SetGradientAlpha(unpack(self.db.profile.Gradient.enable and gradientOnBF or gradientOffBF))
	-- keep a reference to the frame
	self.bottomframe = frame

end

function Skinner:createMiddleFrame(frameId)

	local dbkey = "MiddleFrame"..frameId
	local mfkey = self.db.profile[dbkey]

	self.initialized[dbkey] = true

	local frame = CreateFrame("Frame", "SkinnerMF"..frameId, UIParent)
	frame:SetID(frameId)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetResizable(true)
	frame:SetWidth(mfkey.width)
	frame:SetHeight(mfkey.height)
	frame:SetPoint("CENTER", UIParent, "CENTER", mfkey.xOfs, mfkey.yOfs)
	frame:RegisterForDrag("LeftButtonUp")

	if not OnMouseDown then
		OnMouseDown = function()
			local this = this
			if arg1 == "LeftButton" and IsAltKeyDown() then
				this.isMoving = true
				this:StartMoving()
				this:Raise()
			end
			if arg1 == "LeftButton" and IsControlKeyDown() then
				this.isMoving = true
				this:StartSizing("BOTTOMRIGHT")
				this:Raise()
			end
		end
	end
	if self.db.profile.MiddleFrame.lock then
		frame:SetScript("OnMouseDown", function() end)
	else
		frame:SetScript("OnMouseDown", OnMouseDown)
	end
	if not OnMouseUp then
		OnMouseUp = function()
			local this = this
			if arg1 == "LeftButton" then
				if this.isMoving then
					this:StopMovingOrSizing()
					this.isMoving = nil
 					this:SetFrameStrata("BACKGROUND")
					this:SetFrameLevel(0)
					local x, y = this:GetCenter()
					local px, py = this:GetParent():GetCenter()
					local dbkey = "MiddleFrame"..this:GetID()
 					self.db.profile[dbkey].xOfs = x - px
					self.db.profile[dbkey].yOfs = y - py
    				self.db.profile[dbkey].width = math.floor(this:GetWidth())
					self.db.profile[dbkey].height = math.floor(this:GetHeight())
				end
			end
		end
	end
	frame:SetScript("OnMouseUp", OnMouseUp)
	if not OnHide then
		OnHide = function()
	 		if this.isMoving then
	  			this:StopMovingOrSizing()
	  			this.isMoving = nil
	 		end
		end
	end
	frame:SetScript("OnHide", OnHide)

	local fb = self.db.profile.MiddleFrame.borderOff and 0 or 1	
	-- set the fade height
	if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
	-- set the Fade Height to the global value if 'forced'
	-- making sure that it isn't greater than the frame height
		fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
	elseif self.db.profile.MiddleFrame.fheight then
		fh = self.db.profile.MiddleFrame.fheight <= math.ceil(frame:GetHeight()) and self.db.profile.MiddleFrame.fheight or math.ceil(frame:GetHeight())
	end
	self:applySkin(frame, nil, fb, nil, fh)
	frame:SetBackdropColor(self.db.profile.MiddleFrame.r, self.db.profile.MiddleFrame.g, self.db.profile.MiddleFrame.b, self.db.profile.MiddleFrame.a)

	self["middleframe"..frameId] = frame

	frame:Show()

end
