local _G = getfenv(0)

function Skinner:RecipeBook()

-->>-- Options Frame
	self:keepFontStrings(RBOptions_GeneralFrame)
	self:keepFontStrings(RBOptions_SharingFrame)
	self:keepFontStrings(RBOptions_DDFriendShare)
	self:keepFontStrings(RBOptions_DDGuildShare)
	self:keepFontStrings(RBOptions_DDDefaultShare)
	self:keepFontStrings(RBOptions_AuctionFrame)
	self:keepFontStrings(RBOptionsFrame)
	self:moveObject(RBOptionsFrame_TitleText, nil, nil, "-", 6)
	self:applySkin(RBOptionsFrame, true)

	self:keepRegions(RBOptionsFrameTab1, {7,8})
	self:keepRegions(RBOptionsFrameTab2, {7,8})
	self:keepRegions(RBOptionsFrameTab3, {7,8})
	self:moveObject(RBOptionsFrameTab2, "+", 10, nil, nil)
	self:moveObject(RBOptionsFrameTab3, "+", 10, nil, nil)
	if self.db.profile.TexturedTab then self:applySkin(RBOptionsFrameTab1, nil, 0)
	else self:applySkin(RBOptionsFrameTab1) end
	if self.db.profile.TexturedTab then self:applySkin(RBOptionsFrameTab2, nil, 0)
	else self:applySkin(RBOptionsFrameTab2) end
	if self.db.profile.TexturedTab then self:applySkin(RBOptionsFrameTab3, nil, 0)
	else self:applySkin(RBOptionsFrameTab3) end

	if self.db.profile.TexturedTab then
		self:setActiveTab(RBOptionsFrameTab1)
		self:setInactiveTab(RBOptionsFrameTab2)
		self:setInactiveTab(RBOptionsFrameTab3)
		self:SecureHook("RBOptionsFrame_OnUpdate", function()
			self:setInactiveTab(RBOptionsFrameTab1)
			self:setInactiveTab(RBOptionsFrameTab2)
			self:setInactiveTab(RBOptionsFrameTab3)
			self:setActiveTab(_G["RBOptionsFrameTab"..RBOptionsFrame.selectedTab])
			end)
	end

-->>-- Main Frame
	self:keepFontStrings(RBUI_MainFrame)
	
	self:applySkin(RBUI_MainFrame, true)
	self:moveObject(RBUI_MainFrame_TitleText, nil, nil, "-", 6)
	self:keepRegions(RBUI_MainFrameTab1, {7,8})
	self:keepRegions(RBUI_MainFrameTab2, {7,8})
	self:keepRegions(RBUI_MainFrameTab3, {7,8})
	self:keepRegions(RBUI_MainFrameTab4, {7,8})
	self:moveObject(RBUI_MainFrameTab1, "+", 10, nil, nil)
	self:moveObject(RBUI_MainFrameTab2, "+", 10, nil, nil)
	self:moveObject(RBUI_MainFrameTab3, "+", 10, nil, nil)
	self:moveObject(RBUI_MainFrameTab4, "+", 10, nil, nil)
	if self.db.profile.TexturedTab then self:applySkin(RBUI_MainFrameTab1, nil, 0)
	else self:applySkin(RBUI_MainFrameTab1) end
	if self.db.profile.TexturedTab then self:applySkin(RBUI_MainFrameTab2, nil, 0)
	else self:applySkin(RBUI_MainFrameTab2) end
	if self.db.profile.TexturedTab then self:applySkin(RBUI_MainFrameTab3, nil, 0)
	else self:applySkin(RBUI_MainFrameTab3) end
	if self.db.profile.TexturedTab then self:applySkin(RBUI_MainFrameTab4, nil, 0)
	else self:applySkin(RBUI_MainFrameTab4) end

	if self.db.profile.TexturedTab then
		self:setActiveTab(RBUI_MainFrameTab1)
		self:setInactiveTab(RBUI_MainFrameTab2)
		self:setInactiveTab(RBUI_MainFrameTab3)
		self:setInactiveTab(RBUI_MainFrameTab4)
		self:SecureHook("RBUI_MainFrame_OnUpdate", function()
			self:setInactiveTab(RBUI_MainFrameTab1)
			self:setInactiveTab(RBUI_MainFrameTab2)
			self:setInactiveTab(RBUI_MainFrameTab3)
			self:setInactiveTab(RBUI_MainFrameTab4)
			self:setActiveTab(_G["RBUI_MainFrameTab"..RBUI_MainFrame.selectedTab])
			end)
	end
	
-->>-- Main Frame Sub Frames
	self:skinEditBox(RBUI_SearchFrame_EDIT_SearchFor, {9})
	self:keepFontStrings(RBUI_SearchFrame_ResultsScrollFrame)
	self:skinScrollBar(RBUI_SearchFrame_ResultsScrollFrame)

	self:keepFontStrings(RBUI_SkillFrame_DD_ChoosePlayer)
	self:keepFontStrings(RBUI_SkillFrame_ScrollFrame)
	self:skinScrollBar(RBUI_SkillFrame_ScrollFrame)
	
	self:keepFontStrings(RBSkillTrackFrame)
	self:applySkin(RBSkillTrackFrame)
	
	self:keepFontStrings(RBUI_SharingFrame_WhoScrollFrame)
	self:skinScrollBar(RBUI_SharingFrame_WhoScrollFrame)
	
-->>-- Tooltips
	self:skinTooltip(RecipeBookTooltip)
	self:skinTooltip(RBDB_ScanningTooltip)
	self:skinTooltip(RecipeBookUITooltip)

end
