
function Skinner:WIM()

	-- Track this event to handle Windowed to Fullscreen and vice versa changes
	self:RegisterEvent("UPDATE_FLOATING_CHAT_WINDOWS", "WIM_SkinFrames")

-->>-- History Frame
	if not WIM_HistoryFrame.skinned then 
		self:keepFontStrings(WIM_HistoryExportFormatMenu)
		self:keepFontStrings(WIM_HistoryFrameNameListScrollBar)
		self:skinScrollBar(WIM_HistoryFrameNameListScrollBar)
		self:keepFontStrings(WIM_HistoryFrameFilterListScrollBar)
		self:skinScrollBar(WIM_HistoryFrameFilterListScrollBar)
		self:keepFontStrings(WIM_HistoryViewerExportFormat)
		self:skinScrollBar(WIM_HistoryViewerExportFormat)
		self:applySkin(WIM_HistoryFrame)
		WIM_HistoryFrame.skinned = true
	end
	                     
-->>-- Help Frame	
	WIM_HelpTitleBorder:Hide()
	self:moveObject(WIM_HelpExitButton, "+", 10, "+", 10)
	self:keepFontStrings(WIM_HelpScrollFrame)
	self:skinScrollBar(WIM_HelpScrollFrame)
	self:applySkin(WIM_HelpFrame)
	self:applySkin(WIM_Help)

-->>-- Conversation Menu 
	self:applySkin(WIM_ConversationMenu)
	
-->>-- Toggle Window
	self:applySkin(WIM_ToggleWindow)

-->>--  Message Frame(s)
	self:SecureHook("WIM_PostMessage", function(user, msg, ttype, from, raw_msg, skipWhoQuery, msgID)
		-- self:Debug("WIM_PM: [%s, %s, %s, %s, %s, %s, %s]", user, msg, ttype, from, raw_msg, skipWhoQuery, msgID)
		self:WIM_SkinFrames(false)
		end)

-->>-- Tooltip
	if self.db.profile.Tooltips.skin then
		self:skinTooltip(WIM_Icon_ToolTip)
		if self.db.profile.Tooltips.style == 3 then WIM_Icon_ToolTip:SetBackdrop(backdrop) end
	end
	table.insert(ttCheck, WIM_Icon_ToolTip)

end

local WIMSkinned = {}

function Skinner:WIM_SkinFrames(respectSkin)

	for k, v in pairs(WIM_Windows) do
		-- self:Debug("WIM_SF: [%s, %s, %s]", k, v, respectSkin)
		if WIM_Windows[k] and not (WIMSkinned[k] and respectSkin) then
			local frame = _G["WIM_msgFrame"..k]
			local eb    = _G[frame:GetName().."MsgBox"]
			if not WIMSkinned[k] then
				self:skinEditBox(eb, {9})
				self:moveObject(_G[frame:GetName().."ExitButton"], "-", 2, nil, nil)
				self:moveObject(eb, "-", 10, "-", 2)
			end	
			self:keepFontStrings(_G[frame:GetName().."Backdrop"])
			self:applySkin(_G[frame:GetName().."IgnoreConfirm"])
			self:keepFontStrings(frame)
			self:applySkin(frame)
			WIMSkinned[k] = true
		end
	end

end

function Skinner:WIM_Options()

-->>-- Options Frame
	WIM_OptionsTitleBorder:Hide()
	self:moveObject(WIM_OptionsExitButton, "+", 10, "+", 10)
	self:applySkin(WIM_OptionsMiniMap)
	self:applySkin(WIM_OptionsTabbedFrame)
	self:applySkin(WIM_OptionsDisplay)
	self:keepFontStrings(WIM_OptionsDropDownFrame) 
	self:keepFontStrings(WIM_Options_GeneralScroll)
	self:skinScrollBar(WIM_Options_GeneralScroll)
	self:keepFontStrings(WIM_OptionsTabbedFrameWindowWindowMode)
	self:keepFontStrings(WIM_OptionsTabbedFrameWindowCascadeDirection)
	self:keepFontStrings(WIM_OptionsTabbedFrameWindowTabSortOrder)
	self:keepFontStrings(WIM_OptionsTabbedFrameWindowTimeOutFriendMenu)
	self:keepFontStrings(WIM_OptionsTabbedFrameWindowTimeOutNonFriendMenu)
	self:keepFontStrings(WIM_OptionsTabbedFrameHistoryMessageCount)
	self:keepFontStrings(WIM_OptionsTabbedFrameHistoryMaxCount)
	self:keepFontStrings(WIM_OptionsTabbedFrameHistoryAutoDeleteTime)
	self:keepFontStrings(WIM_OptionsTabbedFrameFilterAliasPanelScrollBar)
	self:skinScrollBar(WIM_OptionsTabbedFrameFilterAliasPanelScrollBar)
	self:keepFontStrings(WIM_OptionsTabbedFrameFilterFilteringPanelScrollBar)
	self:skinScrollBar(WIM_OptionsTabbedFrameFilterFilteringPanelScrollBar)
	self:keepFontStrings(WIM_OptionsTabbedFrameHistoryPanelScrollBar)
	self:skinScrollBar(WIM_OptionsTabbedFrameHistoryPanelScrollBar)
	self:keepFontStrings(WIM_Options_PluginScroll)
	self:skinScrollBar(WIM_Options_PluginScroll)
	self:applySkin(WIM_Options)	
	
-->>-- Alias Frame
	WIM_Options_AliasWindowTitleBorder:Hide()
	WIM_Options_AliasWindowPanel1:SetBackdrop(nil)
	WIM_Options_AliasWindowPanel2:SetBackdrop(nil)
	self:moveObject(WIM_Options_AliasWindow_Name, "-", 5, "-", 5)
	self:skinEditBox(WIM_Options_AliasWindow_Name)
	self:moveObject(WIM_Options_AliasWindow_Alias, "-", 5, "-", 5)
	self:skinEditBox(WIM_Options_AliasWindow_Alias)
	self:applySkin(WIM_Options_AliasWindow)
-->>-- Filter Frame
	WIM_Options_FilterWindowTitleBorder:Hide()
	WIM_Options_FilterWindowPanel1:SetBackdrop(nil)
	self:moveObject(WIM_Options_FilterWindow_Name, "-", 5, "-", 5)
	self:skinEditBox(WIM_Options_FilterWindow_Name)
	self:applySkin(WIM_Options_FilterWindow)
-->>-- History Frame
	if not WIM_HistoryFrame.skinned then 
		self:keepFontStrings(WIM_HistoryExportFormatMenu)
		self:keepFontStrings(WIM_HistoryFrameNameListScrollBar)
		self:skinScrollBar(WIM_HistoryFrameNameListScrollBar)
		self:keepFontStrings(WIM_HistoryFrameFilterListScrollBar)
		self:skinScrollBar(WIM_HistoryFrameFilterListScrollBar)
		self:keepFontStrings(WIM_HistoryViewerExportFormat)
		self:skinScrollBar(WIM_HistoryViewerExportFormat)
		self:applySkin(WIM_HistoryFrame)
		WIM_HistoryFrame.skinned = true
	end
	
end
